﻿using System;
using System.Collections.Generic;
using System.Diagnostics;

class CoinChange
{
    static void MakeChange(int[] coins, int amount)// объявляет статический метод (без экземпляра класса) с именем MakeChange, который принимает два аргумента: coins - массив значений монет и amount - сумму, для которой нужно подобрать сдачу.

    {
        Stopwatch stopwatch = new Stopwatch();
        stopwatch.Start();
        Array.Sort(coins);//сортирует массив монет в порядке возрастания.
        Array.Reverse(coins);//переворачивает отсортированный массив, чтобы монеты были в порядке убывания.

        List<int> change = new List<int>();//создает новый пустой список для хранения монет, использованных для сдачи.
        int totalCoins = 0; //инициализирует переменную totalCoins, которая будет хранить общее количество монет в сдаче, значением 0.


        foreach (int coin in coins) // перебирает каждую монету в отсортированном массиве монет.
        {
            while (amount >= coin) //проверяет, является ли сумма больше или равна текущей монете.
            {
                change.Add(coin); //добавляет текущую монету в список сдачи.
                amount -= coin;//вычитает значение текущей монеты из суммы.

                totalCoins++;//величивает счетчик общего количества монет на 1.
            }
        }

        Console.WriteLine("Монеты для сдачи:");//выводит строку "Монеты для сдачи:" в консоль.
        foreach (int coin in change)//перебирает список сдачи
        {
            Console.Write(coin + " ");//выводит каждое значение монеты в консоль, разделяя их пробелами
        }
        Console.WriteLine("\nВсего монет: " + totalCoins);//выводит строку "Всего монет:" в консоль, а затем общее количество монет в сдаче
       
       
        stopwatch.Stop();

        Console.WriteLine($"\nВремя выполнения: {stopwatch.ElapsedMilliseconds} мс");

        // Получаем данные о потреблении памяти
        Process proc = Process.GetCurrentProcess();
        long memoryUsed = proc.PrivateMemorySize64;

        Console.WriteLine($"Использование памяти: {memoryUsed / 1024} KB");
    }

static void Main(string[] args)//объявляет статический метод Main, который является входной точкой программы
    {
        int[] coins = { 25, 10, 5, 1 };//создает массив монет с номиналами 25, 10, 5 и 1.
        int amount = 63;//устанавливает сумму для сдачи в 63 единицы.

        MakeChange(coins, amount);//вызывает метод MakeChange, передавая ему массив монет и сумму.
    }
}
